/**
 * \file: disc.cpp
 *
 */

#include "disc.h"
#include "memtrace.h"

/// Minden irányban ellenőrizzük, hogy kialakult-e a sor
/// @return true, ha kialakult a megfelelő hosszú sor
bool Disc::checkAll() {
    Table::neighbors_type nb = pos.getNeighbors();
    for(Table::neighbors_type::iterator it= nb.begin(); it != nb.end(); ++it) {
        if ((it->second)->check(color, it->first)) {
            setColor(red);  /// kialakult, átváltjuk kezdő korongot is
            return true;
        }
    }
    return false;
}

/// Adott irányban ellenőrizzük, hogy kialakult-e a sor
/// @param col - szín
/// @param dir - irány (0..Table::MaxDir)
/// @param max - azonos korongok száma
/// @return true, ha kialakult a max hosszú sor
bool Disc::check(color_type col, int dir, int max) {
    if (col == color) {
        if (--max == 0) {
            setColor(red);  /// megvan a kellő hossz
            return true;
        } else {
            Disc *dp = pos.getNext(dir);
            if (dp && dp->check(col, dir, max)) {
                setColor(red); /// siker, megy a rekurzió vissza
                return true;
            }
        }
    }
    return false;
}
