/*
 * \file: Disc.h
 */

#ifndef DISC_H
#define DISC_H

#include "table.h"

class Disc {
    Table::Position pos;    ///< tábla pozíció tárolásához
    color_type color;       ///< korong színe
    void setColor(color_type col) { color = col;}
public:
    /// Ha új korongot teszünk le, akkor meg kell nézni hogy kialakult-e valahol a sor.
    /// @param pos - pozíció
    /// @param col - szín
    Disc(Table::Position pos, color_type col = white) :pos(pos), color(col) { }

    /// Az összes szomszéddal megnézi
    bool checkAll();

    /// Egy adott irányt ellenõriz
    /// @param col - szín
    /// @param dir - irány (0..Table::MaxDir)
    /// @param max - azonos korongok száma
    bool check(color_type col, int dir, int max = 4);

    /// @return pozíció
    Table::Position getPosition() const { return pos; }

    /// @return szín
    color_type getColor() const { return color; }
};

#endif // DISC_H
